// GraphicsComponents.cpp
// Chris D'Urso
// 28 August 2005

#include <stdafx.h> 
#include "GraphicsComponents.h"

const int PixelCell::pixel_size = 4;


void PixelCell::update(){
		unsigned char *b = _p;
		unsigned char *e = _p + pixel_size;
		unsigned int *d = argb;
		for(; b < e; ++b, ++d)
			*d = *b ;  
	}

PixelCell& PixelCell::operator=(const PixelCell& rhs){ 
		unsigned char* d = _p;
		const unsigned int*  s = rhs.argb;
		const unsigned int*  e = s + pixel_size;

		for(; s < e; ++s, d++){
			unsigned int a = __min(*s, UCHAR_MAX);
			*d = unsigned char(a);
		}

		return *this; 
	}

PixelCell& PixelCell::operator/(int rhs){ 
		unsigned int* d = argb;
		unsigned int* e = d + pixel_size;

		for(; d<e; ++d)
			*d /= rhs;  
		return *this; 
	}

PixelCell& PixelCell::operator+(const PixelCell& rhs){
		unsigned int* d = argb;
		unsigned int* e = d + pixel_size;
		const unsigned int* s = rhs.argb;

		for(; d<e; ++d, ++s)
			*d = *s + *d;  
		
		return *this;
	};

PixelCell& PixelCell::operator++(){
		_p += pixel_size;
		update();
		return *this;
	}
